// DIRLIST.CPP - Implementation file for your Internet Server
//    DirList Extension

#include "stdafx.h"
#include "DirList.h"

///////////////////////////////////////////////////////////////////////
// The one and only CWinApp object
// NOTE: You may remove this object if you alter your project to no
// longer use MFC in a DLL.

CWinApp theApp;

///////////////////////////////////////////////////////////////////////
// command-parsing map

BEGIN_PARSE_MAP(CDirListExtension, CHttpServer)
	// TODO: insert your ON_PARSE_COMMAND() and 
	// ON_PARSE_COMMAND_PARAMS() here to hook up your commands.
	// For example:

	ON_PARSE_COMMAND(Default, CDirListExtension, ITS_EMPTY)
	ON_PARSE_COMMAND(List, CDirListExtension, ITS_PSTR ITS_PSTR ITS_PSTR ITS_PSTR)
	ON_PARSE_COMMAND_PARAMS("background= textcolor= showpath=yes template=") //internaly template is substituted for doc
	DEFAULT_PARSE_COMMAND(Default, CDirListExtension)
END_PARSE_MAP(CDirListExtension)


///////////////////////////////////////////////////////////////////////
// The one and only CDirListExtension object

CDirListExtension theExtension;


///////////////////////////////////////////////////////////////////////
// CDirListExtension implementation

CDirListExtension::CDirListExtension()
{
}

CDirListExtension::~CDirListExtension()
{
}

BOOL CDirListExtension::GetExtensionVersion(HSE_VERSION_INFO* pVer)
{
	// Call default implementation for initialization
	CHttpServer::GetExtensionVersion(pVer);

	// Load description string
	TCHAR sz[HSE_MAX_EXT_DLL_NAME_LEN+1];
	ISAPIVERIFY(::LoadString(AfxGetResourceHandle(),
			IDS_SERVER, sz, HSE_MAX_EXT_DLL_NAME_LEN));
	_tcscpy(pVer->lpszExtensionDesc, sz);
	return TRUE;
}

BOOL CDirListExtension::TerminateExtension(DWORD dwFlags)
{
	// extension is being terminated
	//TODO: Clean up any per-instance resources
	return TRUE;
}

///////////////////////////////////////////////////////////////////////
// CDirListExtension command handlers

void CDirListExtension::Default(CHttpServerContext* pCtxt)
{
	StartContent(pCtxt);
	
	*pCtxt<<"<p>This ISAPI script was written by Akbar Avliyaev on March 13, 2001";
	*pCtxt<<" akbaraka@yahoo.com</p>";
	*pCtxt<<"<p>The scipt lists the directory content in a better format than";
	*pCtxt<<"the default server's page.</p>";
	*pCtxt<<"<p> Usage: put a link in a form</p>";
	*pCtxt<<"<p>&lt;scriptname&gt;&lt;directoty&gt;?List?[background=&lt;color&gt;&textcolor=&lt;color&gt;showpath=yes|no]</p>";
	*pCtxt<<"<p>Where:</p><p> &lt;scriptname&gt; - the name and location of the .dll</p>";
	*pCtxt<<"<p>&lt;directory&gt; - directory to be listed</p>";
	*pCtxt<<"<p>&lt;color&gt; - the color of the background and text in form of RRGGBB, like ff0000 for red</p>";


	EndContent(pCtxt);
}

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CDirListExtension, CHttpServer)
	//{{AFX_MSG_MAP(CDirListExtension)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0



///////////////////////////////////////////////////////////////////////
// If your extension will not use MFC, you'll need this code to make
// sure the extension objects can find the resource handle for the
// module.  If you convert your extension to not be dependent on MFC,
// remove the comments arounn the following AfxGetResourceHandle()
// and DllMain() functions, as well as the g_hInstance global.

/****

static HINSTANCE g_hInstance;

HINSTANCE AFXISAPI AfxGetResourceHandle()
{
	return g_hInstance;
}

BOOL WINAPI DllMain(HINSTANCE hInst, ULONG ulReason,
					LPVOID lpReserved)
{
	if (ulReason == DLL_PROCESS_ATTACH)
	{
		g_hInstance = hInst;
	}

	return TRUE;
}

****/

void CDirListExtension::List(CHttpServerContext* pCtxt,
							 LPCTSTR color, //background color
							 LPCTSTR textcolor, //text color
							 LPCTSTR showpath,   //if yes, show the path name on top
							 LPCTSTR doc
							 )
{
	
	CString wildCard;      
	CString str;
	DWORD size;         
	BOOL moreFiles;         //is there more files in dir?
	char basePath[300];    //the local path
	char scriptName[300]; //the name of the .dll script
	char pathInfo[300];    //the path as client sees it
	char serverName[300];  //the server's name
	char buf[101];

	CFileFind find;
	


	StartContent(pCtxt);
		

  	basePath[0]='\n';
	size=300;
	pCtxt->GetServerVariable("PATH_TRANSLATED",&basePath,&size);
	//testing
	//*pCtxt<<_T("PATH_TRANSLATED")<<basePath<<_T("\n");
	
	scriptName[0]='\n';
	size=300;
	pCtxt->GetServerVariable("SCRIPT_NAME",&scriptName,&size);
	//testing
	//*pCtxt<<_T("SCRIPT_NAME")<<scriptName<<_T("\n");

	pathInfo[0]='\n';
	size=300;
	pCtxt->GetServerVariable("PATH_INFO",&pathInfo,&size);
	//testing
	//*pCtxt<<_T("PATH_INFO")<<pathInfo;

	serverName[0]='\n';
	size=300;
	pCtxt->GetServerVariable("SERVER_NAME",&serverName,&size);
	serverName[0]=toupper(serverName[0]);


	wildCard.Format("%s",basePath);
	wildCard+="\\*.*";
	//testing
	//*pCtxt<<wildCard;


	//write html headers
	*pCtxt << _T("<html> \n");
	*pCtxt << _T("<META name=\"GENERATOR\" content=\"DirList.dll by Akbar Avliyaev akbaraka@yahoo.com\">\n");
	
	*pCtxt << _T("<title>The listing of ")<<pathInfo<<_T("</title>\n");

	if(strlen(doc))
	{
		CFile file;
		CString str;
		str.Format("\\inetpub\\wwwroot\\%s",doc);
		if(file.Open(str,CFile::modeRead|CFile::shareDenyNone))
		{
			int i;
			while(i=file.Read(buf,100)){
				buf[i]=0;
				*pCtxt<<buf;
			}
			file.Close();
			
			
		}
	}
	else
	//set the text and background colors
	*pCtxt << _T("<body bgcolor=\"")<<_T(color)<<_T("\" text=\""<<textcolor<<"\" >\n");
	
	if(strstr(showpath,"yes"))
	//write the path
	*pCtxt <<"<p> <font size=\"5\" >"<<pathInfo<<" on " <<serverName<<"</font></p>\n";

	//create the a table
	*pCtxt<<"<table border=0 width=100%>\n";

	//write the table header
	*pCtxt<<"<tr><td width=80%> File/Dir name<td>Size (bytes)</tr>";	

	//set up search parameters
	moreFiles=find.FindFile(wildCard);
	while(moreFiles){
		moreFiles=find.FindNextFile();
		//print only non system, non dot ('.') files, 
		//non hidded and doesn't start with '_'
		if(!(find.IsDots()||find.IsHidden()||find.IsSystem()
			||(find.GetFileName().GetAt(0)=='_'))){
			
			//write each row as a table row
			*pCtxt<<_T("<tr> <td width=80%>");

			//if it's a directory.
			if(find.IsDirectory()){
				
				//link to the script again
				str.Format("%s",pathInfo);
				str.Replace(" ","%20");
				*pCtxt<<_T("<a href=\"")<<scriptName<<str<<"/";
				str=find.GetFileName();
				str.Replace(" ","%20");
				*pCtxt<<str;
				*pCtxt<<"?List?";
				*pCtxt<<"&background="<<color<<"&textcolor="<<textcolor<<"&showpath="<<showpath<<"&template="<<doc<<"\">";
				str=find.GetFileName();
				str.MakeUpper();
				*pCtxt<<str;
				*pCtxt<<"</a>";
				

			}
			else{//if a file
				//link to the file itself
				*pCtxt<<_T("<a href=\"")<<pathInfo<<"/"<<find.GetFileName()<<"\">";
				str=find.GetFileName();
				str.MakeLower();
				*pCtxt<<str<<"</a>"<<"\n";
			}
			*pCtxt<<_T("</td>\n");

			//if directory, 
			if(find.IsDirectory())
				str.Format("DIR"); //write dir
			else
				//else write size
				str.Format("%d",find.GetLength());
			
			*pCtxt<<"<td width>"<<str<<"</td></tr>";
			
		}
	
	}
	*pCtxt<<"\n</table>\n</body>\n</html>";

}
